﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'version 1.00
'created by: Anele Mashy Mbanga - mbanga.anele@gmail.com
Sub Class_Globals
	'define the type of each button
	Type Btn(id As String, width As String, height As String, tooltiptext As String,text As String, icon As String)
	'list of buttons to add
	Private Buttons As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	'clear the buttons
	Buttons.Initialize
End Sub

'each a button without text
Sub AddButton(id As String, width As String, height As String,tooltiptext As String, icon As String) As clsToolBar
	AddButtonText(id,"",width,height,tooltiptext,icon)
	Return Me
End Sub

'each a button to the collection, ensure no duplicated ids
Sub AddButtonText(id As String, text As String, width As String, height As String,tooltiptext As String, icon As String) As clsToolBar
	Dim eachBtn As Btn
	eachBtn.Initialize
	eachBtn.id = id
	eachBtn.height = height
	eachBtn.width = width
	eachBtn.text = text
	eachBtn.icon = icon
	eachBtn.tooltiptext = tooltiptext
	Buttons.Put(id.tolowercase,eachBtn)
	Return Me
End Sub


Sub AddButtonTextOnly(id As String,text As String) As clsToolBar
	AddButtonText(id, text, "", "","", "")
	Return Me
End Sub


'add a 30x100 button (default)
Sub AddButtonDef(id As String,tooltiptext As String, icon As String) As clsToolBar
	AddButtonText(id, "", "100", "30",tooltiptext, icon)
	Return Me
End Sub

'add a 16x16 button
Sub AddButton16(id As String,tooltiptext As String, icon As String) As clsToolBar
	AddButtonText(id, "", "16", "16",tooltiptext, icon)
	Return Me
End Sub

'add a 32x32 button
Sub AddButton32(id As String,tooltiptext As String, icon As String) As clsToolBar
	AddButtonText(id, "", "32", "32",tooltiptext, icon)
	Return Me
End Sub

'add a 48x48 button
Sub AddButton48(id As String,tooltiptext As String, icon As String) As clsToolBar
	AddButtonText(id, "", "48", "48",tooltiptext, icon)
	Return Me
End Sub

'add a separatot
Sub AddSeparator() As clsToolBar
	Dim btnSize As Int = Buttons.Size
	Dim btnID As String = $"sep_${btnSize}"$
	AddButtonText(btnID,"-","","","","")
	Return Me
End Sub

'build each button code
private Sub BuildButton(eachBtn As Btn) As String
	If eachBtn.IsInitialized = False Then Return ""
	Dim id As String = eachBtn.id
	Dim text As String = eachBtn.text
	Dim width As String = eachBtn.width
	Dim height As String = eachBtn.height
	Dim tooltiptext As String = eachBtn.tooltiptext
	Dim icon As String = eachBtn.icon
	'start building the button
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	'this is a separator
	If id.startswith("sep_") Then
		sb.Append(CreatePropertyText("text",text))
	Else
		'id is compulsory otherwise others are not
		sb.Append(CreatePropertyText("id",id))
		If width.Length > 0 Then sb.Append(",").Append(CreatePropertyValue("width",width))
		If height.Length > 0 Then sb.Append(",").Append(CreatePropertyValue("height",width))
		If text.Length > 0 Then sb.Append(",").Append(CreatePropertyText("text",text))
		If tooltiptext.Length > 0 Then sb.Append(",").Append(CreatePropertyText("tooltiptext",tooltiptext))
		If icon.Length > 0 Then sb.Append(",").Append(CreatePropertyText("icon",icon))
	End If
	sb.append("}")
	Return sb.tostring
End Sub

'build the toolbar, to paste the outcome in the Buttons property
Sub Build() As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[").Append(CRLF)
	For Each eachBtn As Btn In Buttons.Values
		Dim strEach As String = BuildButton(eachBtn)
		If strEach.Length > 0 Then
			sb.append(strEach).Append(",").Append(CRLF)
		End If
	Next
	'remove the delimiters
	If sb.ToString.EndsWith("," & CRLF) Then
		Dim x As String = "," & CRLF
		sb.Remove(sb.Length-x.Length,sb.Length)
		sb.Append(CRLF)
	End If
	sb.Append("]").Append(CRLF)
	Return sb.ToString
End Sub

'build the event manager, only for real buttons exclude separators
Sub Events(tblName As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append($"Sub ${tblName}_Action"$).Append(CRLF)
	sb.Append($"Select ${tblName}.ButtonPressed.Id"$).Append(CRLF)
	For Each eachBtn As Btn In Buttons.Values
		Dim id As String = eachBtn.id
		If id.StartsWith("sep_") Then
		Else
			sb.Append($"Case "${id}""$).Append(CRLF)
		End If
	Next
	sb.Append("End Select").Append(CRLF)
	sb.Append("End Sub").Append(CRLF)
	Return sb.tostring
End Sub

'create a property value
private Sub CreatePropertyValue(propName As String, propValue As String) As String
	Return $""${propName}":${propValue}"$
End Sub

'create a property value
private Sub CreatePropertyText(propName As String, propValue As String) As String
	Return $""${propName}":"${propValue}""$
End Sub
